%define _perl_lib_path %perl_vendor_archlib:%apache_addons_data_dir/webkdc:%apache_addons_data_dir/webauth-tests:%apache_addons_data_dir/webauthldap-tests
%add_findprov_lib_path %perl_vendor_autolib/WebAuth3/

# do webkdc should be built with sident
%def_disable with_sident

# if we do - disable text relocation checking
%if_enabled with_sident
%set_verify_elf_method textrel=relaxed
%endif

Name: webauth
Version: 3.2.3
Release: alt1

Summary: This is a WebAuth LDAP (GSS-API) authentication module for Apache2 
Summary(ru_RU.KOI8-R):   LDAP-  GSS_API  Apache2
Group: System/Servers
License: BSD-like (see README)
Url: http://webauthv3.stanford.edu/


Source: http://webauthv3.stanford.edu/dist/webauth-%version.tar.gz
Source1: webkdc-template.conf
Source2: token-template.acl
Source3: webauth-config-wizard
Source4: webauth.pdf
Source5: webauth-readme.alt.ru_RU.KOI8-R
Source6: webauth-readme.alt.en

Requires: apache2-mod_ssl libcurl libkrb5 libssl
# libsasl2 libsasl2-plugin-gssapi

BuildPreReq: autoconf_2.13 apache2-devel chrpath vhosts-filesystem-devel
Provides: perl(WebAuth3.pm) libwebauth.so.1

# Automatically added by buildreq on Fri Jun 04 2004
BuildRequires: glibc-devel-static libcurl-devel libe2fs-devel libkrb5-devel libldap-devel libssl-devel perl-devel zlib-devel
BuildRequires: %apache_apr_buildreq
BuildRequires: perl-CGI perl-FCGI perl-libwww-perl libsasl2-devel libsasl2-plugin-gssapi

#BuildRequires: libdb4.2 libexpat libgdbm libsasl2-devel libsasl2-plugin-gssapi

AutoReqProv: noperl

%description
WebAuth is a comprehensive system for authenticating web users, built on top
of Apache2. It relies on a login server to which users are redirected at
their first attempt to access a protected web site and implements a protocol
able to use whichever initial user authentication mechanism is convenient to
establish the user's identity. Once the user has logged in to the login server,
their identity is carried in a cookie set by that login server and they will
not again need to enter their password until their credentials expire, even
if they visit multiple different protected web sites.

This package contains libraries and utilities used by WebAuth-aware application.

%description -l ru_RU.KOI8-R
WebAuth     -, 
  - Apache2.    login-,  
       -.
Login-       
 ,       
 .      login-, 
    cookie,  login-
           
         ,    
  -.

      ,   ,
  WebAuth.

%package -n %a_name-mod_webauth
Summary: WebAuth authentication module for Apache web-server
Summary(ru_RU.KOI8-R):     WebAuth  - Apache
Group: System/Libraries
PreReq: %name = %version-%release
Requires: apachkconfig

%description -n %a_name-mod_webauth
WebAuth authentication module for Apache web-server

%description -n %a_name-mod_webauth -l ru_RU.KOI8-R
    WebAuth  - Apache


%package -n %a_name-mod_webauth-tests
Summary: Test suite for WebAuth authentication module of Apache web-server
Summary(ru_RU.KOI8-R):       WebAuth  - Apache
Group: System/Libraries
PreReq: %a_name-mod_webauth = %version-%release
Provides: perl(util.pl)
Requires: apachkconfig

%description -n %a_name-mod_webauth-tests
Test suite for WebAuth authentication module of Apache web-server

%description -n %a_name-mod_webauth-tests -l ru_RU.KOI8-R
      WebAuth  - Apache


%package -n %a_name-mod_webauthldap
Summary: KerberosV authentication module with LDAP authorization for Apache web-server
Summary(ru_RU.KOI8-R):    Kerberos5    LDAP  - Apache
Group: System/Libraries
PreReq: %a_name-mod_webauth = %version-%release libldap libsasl2-plugin-gssapi
Requires: apachkconfig

%description -n %a_name-mod_webauthldap
Kerberos5(via GSS-API) authentication module with LDAP authorization
for Apache web-server

%description -n %a_name-mod_webauthldap -l ru_RU.KOI8-R
   Kerberos5 ( GSS-API)    LDAP
 - Apache


%package -n %a_name-mod_webauthldap-tests
Summary: Test suite for KerberosV authentication module with LDAP authorization of Apache web-server
Summary(ru_RU.KOI8-R):      KerberosV    LDAP  - Apache
Group: System/Libraries
PreReq: %a_name-mod_webauthldap = %version-%release
Provides: perl(util.pl)
Requires: apachkconfig

%description -n %a_name-mod_webauthldap-tests
Test suite for KerberosV(via GSS-API) authentication module with LDAP authorization
of Apache web-server

%description -n %a_name-mod_webauthldap-tests -l ru_RU.KOI8-R
     KerberosV ( GSS-API)  
 LDAP  - Apache

%package -n %a_name-mod_webkdc
Summary: Authentication server for WebAuth-enabled web-servers running as a module for Apache web-server
Summary(ru_RU.KOI8-R):    -,  WebAuth,     - Apache
Group: System/Servers
PreReq: %name = %version-%release
Requires: apache2 perl-FCGI perl-i18n
Requires: apachkconfig

AutoReqProv: noperl

%description -n %a_name-mod_webkdc
Authentication server for WebAuth-enabled web-servers running as a module for Apache web-server

%description -n %a_name-mod_webkdc -l ru_RU.KOI8-R
   -,  WebAuth,     - Apach

%prep
%setup -q
%__cp %SOURCE4 %SOURCE5 %SOURCE6 doc/
 
%build
# fix apxs installpath in Makefile.in before configure
%__perl -pi -e "s,([[:blank:]]*)(.*APXS\) -i) (.*)\..*,\$1install -m755 .libs/\$3.so %buildroot%apache_moduledir," \
        src/modules/webauthldap/Makefile.in \
        src/modules/webauth/Makefile.in \
        src/modules/webkdc/Makefile.in

# Don't let make to build perl libs. We'll do it better
%__perl -pi -e "s:.*PERL\).*:# Disabled:" \
        src/bindings/perl/Makefile.in 
%__perl -pi -e "s:.*MAKE\).*:# Disabled:" \
        src/bindings/perl/Makefile.in 
# Fix paths and locations
%__perl -pi -e "s:\\$\(APACHE_ROOT\)/conf:%apache_confdir:" \
        tests/Makefile.in 
%__perl -pi -e "s:\\$\(APACHE_ROOT\)/htdocs:%apache_addons_data_dir/webauth-tests:" \
        tests/Makefile.in 
find ./ -type f -exec %__perl -pi -e "s|/usr/local/bin/perl|%__perl|g" {} \;

###
## Configure&Build
# 
export KRB5_CPPFLAGS="-I/usr/include/krb5 -I/usr/include/et"
%configure \
	--with-apache=%apache_addons_data_dir \
	--with-apxs=%apache_apxs \
	--libexecdir=%apache_moduledir \
	--enable-mod_webkdc \
	--enable-perl \
%if_enabled with_sident
	--enable-sident
%elseif
	--disable-sident
%endif

%make_build
#
#=> Build perl bindings
#
pushd src/bindings/perl/WebAuth3
export LD_LIBRARY_PATH=../../../libwebauth/.libs
%perl_vendor_build
popd
#=> Checking
%make check


%install
###
## Create directories
#
%__install -d \
    %buildroot%a_libexecdir \
    %buildroot%apache_confdir/webkdc \
    %buildroot%apache_confdir/webauth

%__install -d \
    %buildroot%_sbindir \
    %buildroot%apache_confdir \
    %buildroot%apache_addonconfdir \
    %buildroot%apache_vhostconfdir \
    %buildroot%apache_addonvhostconfdir \
    %buildroot%apache_addondocdir \
    %buildroot%apachk_addon_initd \
    %buildroot%apache_addons_data_dir/webauth-tests \
    %buildroot%apache_addons_data_dir/webauthldap-tests
###
## Real install
#    
%makeinstall
%make install-webkdc DESTDIR=%buildroot

pushd src/bindings/perl/WebAuth3
%perl_vendor_install
popd

###
## Install main and test's configuration files; Install docs 
#
%__install conf/stanford-webauth.conf %buildroot%apachk_addon_initd/webauth.conf
%__install conf/stanford-ldap.conf %buildroot%apachk_addon_initd/webauthldap.conf

pushd tests/mod_webauth/conf/
%__install webauth-tests.conf %buildroot%apachk_addon_initd/webauth-tests.conf
%__install ldaptests.conf %buildroot%apachk_addon_initd/webauthldap-tests.conf
popd

%__install %SOURCE1 %buildroot%apache_addonvhostconfdir/T.webkdc.conf

%__install -m644 doc/mod_web*.html* %buildroot%apache_addondocdir/

### 
## Hack configs
#
#=> Fix default location to be the the same as it for kerberos
#
%__subst "s,service/webkdc@stanford.edu,service/webkdc@EXAMPLE.COM,g
s,stanford\.edu,example.com,g
s,\/webkdc-service\/,:8443/webkdc-service/,g
s,\/login\/,:8443/login/,g
1 i \
# This is configuration file for webauth module \\
# apachkconfig - 02 2 \\
# description: A WebAuth (GSS-API) authentication module for Apache2 \\
 \
" %buildroot%apachk_addon_initd/webauth.conf

%__subst "s/stanford\.edu/example.com/g
s/cn=\(.*\),dc=stanford,dc=edu/ou=\1,dc=example,dc=com/g
1 i \
# This is configuration file for webauthldap module \\
# apachkconfig - 03 2 \\
# description: A WebAuthLdap (LDAP via GSS-API) authorization module for Apache2 \\
 \
" %buildroot%apachk_addon_initd/webauthldap.conf

%__subst "1 i \
<IfModule mod_ssl.c> \\
##### Copy me to A.webkdc.conf to activate \\
#
s:-=apache_datadir=-:%apache_addons_data_dir:g
s:-=apache_confdir=-:%apache_confdir:g
$ a \
</IfModule> \

" %buildroot%apache_addonvhostconfdir/T.webkdc.conf

#=> Fix test suite configs and locations
#
# Remove unneeded comments for head of config and
# tune up test-suites config files 
#

%__subst "s,\/tests\/,\/webauth-tests\/,
1,/##### Allow access to tests/d
/<Location \/webauth-tests\/>/i \
# This is configuration file for test suite of webauth module \\
# apachkconfig - 36 2 \\
# description: A WebAuth Test suite \\
 \\
Alias /webauth-tests/ '%apache_addons_data_dir/webauth-tests/' \\
 \\
" %buildroot%apachk_addon_initd/webauth-tests.conf


#1,/#########/d

%__subst "s,\/ldaptests\/,\/webauthldap-tests\/,
1,/#########/d
/WebAuthAuthType/ i \
# This is configuration file for test suite of webauthldap module \\
# apachkconfig - 37 2 \\
# description: A WebAuthLDAP Test suite \\
 \\
Alias /webauthldap-tests/ '%apache_addons_data_dir/webauthldap-tests/' \\
 \\
" %buildroot%apachk_addon_initd/webauthldap-tests.conf

#1/<Location \/webauthldap-tests\/>/i \

###
## Tune-up locations in WebKDC cgi
#
%__subst "
s,\.\.\/conf\/,%apache_confdir/,
s,/etc/webkdc/webkdc.conf,%apache_confdir/webkdc/cgi.conf,
s,localhost\/webkdc-service\/,weblogin.example.com:8443/webkdc-service/,
" %buildroot%apache_addons_data_dir/webkdc/WebKDC/Config.pm 

###
## Install customization file for WebKDC cgi
#
echo '# Here you can place your overrides for WebKDC Perl module.
# Most likely you want to set correct webkdc URL and specify
# your custom WebKDC cgi templates location
# Defaults follows:
our $URL = "https://weblogin.example.com:8443/webkdc-service/";
#our $KEYRING_PATH = "%apache_confdir/webkdc/keyring";
#our $TEMPLATE_PATH = "%apache_addons_data_dir/webkdc/generic/templates";
' > %buildroot%apache_confdir/webkdc/cgi.conf

### 
## Install test suites
#
%__cp -r tests/mod_webauth/htdocs/tests/* %buildroot%apache_addons_data_dir/webauth-tests/
%__cp -r tests/mod_webauth/htdocs/ldaptests/* %buildroot%apache_addons_data_dir/webauthldap-tests/
#
#=> Hack the webauthldap-test cgis
#
pushd %buildroot%apache_addons_data_dir/webauthldap-tests
#-> Remove duplicates
    find ./ -type d -name "test?" \
	-exec %__rm -f {}/util.pl \;
#-> Fix locations
    find ./ -type f -name "test" \
	-exec %__subst "s:\(util.pl\):../\1:
	s:\/ldaptests\/:/webauthldap-tests/:g" {} \;
    %__subst "s:\/ldaptests\/:/webauthldap-tests/:g" util.pl
#-> Tune permissions
    %__chmod 644 util.pl
popd
#
#=> Hack the webauth-test cgis
#
pushd %buildroot%apache_addons_data_dir/webauth-tests
#-> Fix locations
    find %buildroot%apache_addons_data_dir -type f \
	-exec %__subst "s:\/tests\/:\/webauth-tests\/:g" {} \;
popd

###
## Install config wizard (for now it only substitude example.com by local domain name)
#
%__install -m700 %SOURCE3 %buildroot%_sbindir
CONFFILES="%apachk_addon_initd/webauth.conf \
%apachk_addon_initd/webauthldap.conf \
%apachk_addon_initd/webauth-tests.conf \
%apachk_addon_initd/webauthldap-tests.conf \
%apache_addonvhostconfdir/T.webkdc.conf \
%apache_confdir/webkdc/cgi.conf \
%apache_confdir/webkdc/token.acl"
%__subst "s:-=FILELIST=-:$CONFFILES:g" %buildroot%_sbindir/webauth-config-wizard
###
## Install example tokel.acl and empty keytabs 
#
%__install %SOURCE2 %buildroot%apache_confdir/webkdc/token.acl
touch \
    %buildroot%apache_confdir/webauth/keytab \
    %buildroot%apache_confdir/webkdc/keytab

###
## Removing unpackaged files
#
# for now we don't have devel package
%__rm -f %buildroot%_includedir/webauth.h

###
## Remove RPATH in WebAuth3.so and modules
#
chrpath -d \
    %buildroot%perl_vendor_autolib/WebAuth3/WebAuth3.so \
    %buildroot%a_libexecdir/mod_webauth.so \
    %buildroot%a_libexecdir/mod_webauthldap.so \
    %buildroot%a_libexecdir/mod_webkdc.so

# Hack for find-requires. Has no effect, though. So I use AutoReqProv: noperl
# for mod_webkdc. at@ has a patch for rpm tools to fix this. I'll use
# AutoReqProv: noperl until the new rpmbuild will enter the Sisyphus.
export LD_LIBRARY_PATH=%buildroot%_libdir

%post -n %a_name-mod_webauth
%post_addon webauth

%preun -n %a_name-mod_webauth
%preun_addon webauth

%post -n %a_name-mod_webauthldap
%post_addon webauthldap

%preun -n %a_name-mod_webauthldap
%preun_addon webauthldap

%post -n %a_name-mod_webauth-tests
%post_addon webauth-tests

%preun -n %a_name-mod_webauth-tests
%preun_addon webauth-tests

%post -n %a_name-mod_webauthldap-tests
%post_addon webauthldap-tests

%preun -n %a_name-mod_webauthldap-tests
%preun_addon webauthldap-tests

%files
%_bindir/*
%_libdir/*.*
%attr(0700,root,root) %_sbindir/webauth-config-wizard
%perl_vendor_archlib/WebAuth3.pm
%perl_vendor_autolib/WebAuth3/WebAuth3.so
%perl_vendor_man3dir/*
%_man1dir/*
%doc CHANGES HACKING INSTALL NEWS README
%doc doc/install-webkdc doc/test-plan doc/userauth doc/webauthv3_spec.html doc/webauth.pdf
%doc doc/webauth-readme.alt.ru_RU.KOI8-R doc/webauth-readme.alt.en

%files -n %a_name-mod_webauth
%a_libexecdir/mod_webauth.so
%attr(0700,%apache_user,root) %dir %apache_confdir/webauth
%attr(0400,%apache_user,root) %config(noreplace) %apache_confdir/webauth/keytab
%attr(0600,root,root) %config(noreplace) %apachk_addon_initd/webauth.conf
%apache_addondocdir/mod_webauth.html*

%files -n %a_name-mod_webauth-tests
%attr(0400,%apache_user,root) %config(noreplace) %apachk_addon_initd/webauth-tests.conf
%dir %apache_addons_data_dir/webauth-tests/
%apache_addons_data_dir/webauth-tests/*

%files -n %a_name-mod_webauthldap
%a_libexecdir/mod_webauthldap.so
%attr(0400,%apache_user,root) %config(noreplace) %apachk_addon_initd/webauthldap.conf
%apache_addondocdir/mod_webauthldap.html*

%files -n %a_name-mod_webauthldap-tests
%attr(0400,%apache_user,root) %config %apachk_addon_initd/webauthldap-tests.conf
%dir %apache_addons_data_dir/webauthldap-tests/
%apache_addons_data_dir/webauthldap-tests/*

%files -n %a_name-mod_webkdc
%a_libexecdir/mod_webkdc.so
%attr(0400,%apache_user,root) %config %apache_addonvhostconfdir/T.webkdc.conf
%attr(0700,%apache_user,root) %dir %apache_confdir/webkdc/
%attr(0400,%apache_user,root) %config(noreplace) %apache_confdir/webkdc/token.acl
%attr(0400,%apache_user,root) %config(noreplace) %apache_confdir/webkdc/keytab
%attr(0400,%apache_user,root) %config(noreplace) %apache_confdir/webkdc/cgi.conf
%dir %apache_addons_data_dir/webkdc/
%apache_addons_data_dir/webkdc/*
%apache_addondocdir/mod_webkdc.html*

%changelog
* Fri Jul 02 2004 Yury Konovalov <yurix@altlinux.ru> 3.2.3-alt1
- 3.2.3
- cgi.conf added for configuring WebKDC cgi.
- License value corrected in spec. Changed to BSD-like,
  since it looks like BSD.

* Tue Jun 29 2004 Yury Konovalov <yurix@altlinux.ru> 3.2.2-alt2
- make use the apachkconfig macroses.
- rebuild with apache 2.0.50

* Sun Jun 06 2004 Yury Konovalov <yurix@altlinux.ru> 3.2.2-alt1
- spec clean-up
- more default configs tune-ups added to simplify implementing
  of WebAuth.
- move WebKDC virthost config to vhost.d-addon  
- added webauth-readme.alt.ru_RU.KOI8-R and webauth-readme.alt-en
  focused on quickstarting WebAuth
- webauth-config-wizard now usable

* Tue May 25 2004 Yury Konovalov <yurix@altlinux.ru> 3.2.2-alt0.1
- 3.2.2
- fixed permission on config files
- empty keytabs added
- build with ab@ libkrb5-devel

* Fri Dec 12 2003 Yury Konovalov <yurix@altlinux.ru> 3.2.1-uc5
- added ldapbase replace mech to adopt-domain-in-confs.sh config
  script
- adopt-domain-in-confs.sh moved to /usr/sbin and renamed
  to webauth-conf-autoadjust

* Thu Dec 11 2003 Yury Konovalov <yurix@altlinux.ru> 3.2.1-uc4
- move tests to separate packages
- add adopt-domain-in-confs.sh config script

* Tue Nov 03 2003 Yury Konovalov <yurix@altlinux.ru> 3.2.1-uc3
- rebuild with Apache 2.0.48
- spec clean-up

* Tue Sep 11 2003 Yury Konovalov <yurix@altlinux.ru> 3.2.1-uc2
- rebuild with MIT kerberos 1.3.1

* Tue Sep 11 2003 Yury Konovalov <yurix@altlinux.ru> 3.2.1-uc1
- 3.2.1

* Tue Sep 09 2003 Yury Konovalov <yurix@altlinux.ru> 3.2.0-uc2
- split into several packages

* Thu Sep 04 2003 Yury Konovalov <yurix@altlinux.ru> 3.2.0-uc1.1
- rebuild with mod_webkdc

* Wed Sep 03 2003 Yury Konovalov <yurix@altlinux.ru> 3.2.0-uc1
- 3.2.0

* Tue Aug 19 2003 Yury Konovalov <yurix@altlinux.ru> 3.1.2-uc1
- first build for ALT Linux Sisyphus
